FWRITE_	MACRO	GIE_OFF, ZAVADEC
; provede zapis do FLASH pameti
; - GIE_OFF urcuje, zda se ma program starat o zakazani preruseni
;           jednicka rika, ze ano
; - ZAVADEC rika, zda se ma chranit cast pameti, ktera obsahuje zavadec
;           pokud je zde jednicka, potom je ochrana aktivni.

	LOCAL	SKOK, KONEC

	banksel	EECON1	; pockame na ukonceni posledniho zapisu do EEPROM
	BTFSC	EECON1,WR
	GOTO	$ - 1

	IF ZAVADEC==1	; alternativni ochrana zavadece
	banksel	EEADRH
	MOVF	EEADRH,W
	ANDLW	B'00011110'
	XORLW	B'00011110'
	BTFSC	STATUS,Z
	GOTO	KONEC
	MOVF	EEADRH,W
	ANDLW	B'00011111'
	BTFSS	STATUS,Z
	GOTO	SKOK
	MOVLW	D'3'
	SUBWF	EEADR,W
	BTFSS	STATUS,C
	GOTO	KONEC
	ENDIF	
SKOK
	banksel	EECON1	; zahajuje se zapis
	BSF	EECON1,EEPGD
	BSF	EECON1,WREN
	IF GIE_OFF==1	; pripadne zakazeme preruseni
	BCF	INTCON,GIE
	BTFSC	INTCON,GIE
	GOTO	$ - 2
	ENDIF
	MOVLW	H'55'
	MOVWF	EECON2
	MOVLW	H'AA'
	MOVWF	EECON2
	BSF	EECON1,WR
	NOP
	NOP
	IF GIE_OFF==1
	BSF	INTCON,GIE	; pripadne opet povolime preruseni
	ENDIF
	BCF	EECON1,WREN
KONEC
	banksel	D'0'

	ENDM

FREAD_	MACRO
; provede cteni z FLASH pameti

	banksel	EECON1	; pockame na ukonceni posledniho zapisu do EEPROM
	BTFSC	EECON1,WR
	GOTO	$ - 1
	banksel	EECON1
	BSF	EECON1,EEPGD
	BSF	EECON1,RD
	NOP
	NOP
	banksel	D'0'

	ENDM
